/////////////////////////////////////////////////////////////////////////

import { LevelTemplate } from './levels.js'

/////////////////////////////////////////////////////////////////////////

export const LevelDefs = [
    new LevelTemplate({
        name: 'Newcomer',
        blurb: "Your PR has been merged and it's time to start pushing packets.",
        units: 'packets',
        cost: BigInt(1),
        unlocked: true
    }),
    
    new LevelTemplate({
        name: 'Peering Pro',
        blurb: 'Increase the number of peers to get more packets.',
        units: 'peers',
        cost: BigInt(10)
    }),

    new LevelTemplate({
        name: 'IPv6 Rollout',
        blurb: 'Rollout IPv6 across your network.',
        units: 'link local addresses',
        cost: BigInt(100)
    }),

    new LevelTemplate({
        name: 'Routing Updates',
        blurb: 'Optimise your bird config to get ROA filters (look, no-one said this should make sense).',
        units: 'ROA filters',
        cost: BigInt(1000)
    }),

    new LevelTemplate({
        name: 'Node Operator',
        blurb: 'Expand your global footprint with new nodes.',
        units: 'low end vps',
        cost: BigInt(10000)
    }),

    new LevelTemplate({
        name: 'Security Guru',
        blurb: 'Improve your security by implementing firewalls.',
        units: 'firewalls',
        cost: BigInt(100000)
    }),

    new LevelTemplate({
        name: 'File Sharing',
        blurb: 'Spread your packets around.',
        units: 'files transferred',
        cost: BigInt(1000000)
    }),

    new LevelTemplate({
        name: 'Anycast Deployment',
        blurb: 'Create resilient global services.',
        units: 'paths',
        cost: BigInt(10000000)
    }),

    new LevelTemplate({
        name: 'Community Member',
        blurb: 'Help others by contributing to the wiki.',
        units: 'wiki edits',
        cost: BigInt(100000000)
    }),

    new LevelTemplate({
        name: 'Multicast Streamer',
        blurb: 'Use up all your bandwidth streaming music and video.',
        units: 'streams',
        cost: BigInt(1000000000)
    }),

    new LevelTemplate({
        name: 'DN42 Master',
        blurb: 'The network must grow !',
        units: 'rp_filters disabled',
        cost: BigInt(10000000000)
    })

]

/////////////////////////////////////////////////////////////////////////
// end of file