/////////////////////////////////////////////////////////////////////////
// number functions

const SISym = [
    '', 'K', 'M', 'G', 'T', 'P', 'E', 'Z', 'Y', 'R', 'Q'
]

export function nstr(big) {

    let m = 0
    let r = 0
    const onek = BigInt(1000)

    while (big >= onek) {
        r = Number(big % onek)
        big /= onek
        m++
    }

    // convert to fraction
    let n = Number(big)
    let f = n + (r / 1000)

    if (m == 0) {
        // simple number
        return n.toString()
    } else if (m < SISym.length) {
        // with SI suffix
        return f.toFixed(2) + SISym[m]
    } else {
        // scientific notation
        m *= 3
        while (f > 10) {
            f /= 10
            m++
        }
        return f.toFixed(2) + 'e' + m
    }

}

/////////////////////////////////////////////////////////////////////////
// end of file