/////////////////////////////////////////////////////////////////////////
// level functions

export class Services {
    constructor() {

        this.time = {
            unlocked: false,
            level: 0,

        }
        this.auto = {
            unlocked: false,
            level: 0
        }
        this.upgrade = {
            unlocked: false,
            level: 0
        }

    }

    // save data
    save() {
        let save_data = {
            time: this.time,
            auto: this.auto,
            upgrade: this.upgrade
        }
        return save_data
    }

    restore(save_data) {
        Object.assign(this, save_data)
    }

    tick(state, interval) {
        if (state.levels[2].count > 0) { this.auto.unlocked = true }
        if (state.levels[3].count > 0) { this.time.unlocked = true }
        if (state.levels[5].count > 0) { this.upgrade.unlocked = true }
    }

    // time costs
    tCost() {
        switch (this.time.level) {
            case 0:
                return 1000000n
            case 1:
                return 1000000000n
            default:
                return 0n
        }
    }

    tUnits(state) {
        return state.levels[(this.time.level * 2) + 3].units
    }

    tValue(state) {
        return state.levels[(this.time.level * 2) + 3].count
    }

    tUpgrade(state) {
        state.levels[(this.time.level * 2) + 3].count -= this.tCost()
        this.time.level++
    }

    // auto costs
    aCost() {
        switch (this.auto.level) {
            case 0:
                return 1000000n
            case 1:
                return 1000000000n
            default:
                return 0n
        }
    }

    aUnits(state) {
        return state.levels[(this.auto.level * 2) + 2].units
    }

    aValue(state) {
        return state.levels[(this.auto.level * 2) + 2].count
    }

    aUpgrade(state) {
        state.levels[(this.auto.level * 2) + 2].count -= this.aCost()
        this.auto.level++
    }

    // auto costs
    uCost() {
        switch (this.upgrade.level) {
            case 0:
                return 1000000n
            case 1:
                return 1000000000n
            default:
                return 0n
        }
    }

    uUnits(state) {
        return state.levels[this.upgrade.level + 6].units
    }

    uValue(state) {
        return state.levels[this.upgrade.level + 6].count
    }

    uUpgrade(state) {
        state.levels[this.upgrade.level + 6].count -= this.uCost()
        this.upgrade.level++
    }

}

/////////////////////////////////////////////////////////////////////////
// end of file